<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('WPsite_Popups_Admin_Functions') ) :

// AJAX calls to load stats and emails

add_action( 'wp_ajax_wps_pf_stats_load', 					array('WPsite_Popups_Admin_Functions', 'stats_load'));
add_action( 'wp_ajax_wps_pf_emails_load', 					array('WPsite_Popups_Admin_Functions', 'emails_load'));
add_action( 'wp_ajax_wps_pf_entries_load', 					array('WPsite_Popups_Admin_Functions', 'entries_load'));
add_action( 'wp_ajax_wps_pf_entry_load', 					array('WPsite_Popups_Admin_Functions', 'entry_load'));

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_wps_pf_get_categories', 				array('WPsite_Popups_Admin_Functions', 'get_categories'));
add_action( 'wp_ajax_wps_pf_get_tags', 						array('WPsite_Popups_Admin_Functions', 'get_tags'));
add_action( 'wp_ajax_wps_pf_get_posts', 					array('WPsite_Popups_Admin_Functions', 'get_posts'));

// AJAX calls to get Newsletter lists

add_action( 'wp_ajax_wps_pf_get_mailchimp_lists', 			array('WPsite_Popups_Admin_Functions', 'get_mailchimp_lists'));
add_action( 'wp_ajax_wps_pf_get_aweber_lists', 				array('WPsite_Popups_Admin_Functions', 'get_aweber_lists'));
add_action( 'wp_ajax_wps_pf_get_getresponse_lists', 		array('WPsite_Popups_Admin_Functions', 'get_getresponse_lists'));
add_action( 'wp_ajax_wps_pf_get_campaignmonitor_lists', 	array('WPsite_Popups_Admin_Functions', 'get_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_pf_update_campaignmonitor_lists', 	array('WPsite_Popups_Admin_Functions', 'update_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_pf_get_madmimi_lists', 			array('WPsite_Popups_Admin_Functions', 'get_madmimi_lists'));
add_action( 'wp_ajax_wps_pf_get_infusionsoft_lists', 		array('WPsite_Popups_Admin_Functions', 'get_infusionsoft_lists'));
add_action( 'wp_ajax_wps_pf_get_mymail_lists', 				array('WPsite_Popups_Admin_Functions', 'get_mymail_lists'));
add_action( 'wp_ajax_wps_pf_get_activecampaign_lists', 		array('WPsite_Popups_Admin_Functions', 'get_activecampaign_lists'));

// General AJAX calls for popups on the amdin screen

add_action( 'wp_ajax_wps_pf_clear_cache', 					array('WPsite_Popups_Admin_Functions', 'clear_popup_cache'));

// Cron jobs

add_action( 'initialize_popup_stats_daily_cron', 			array('WPsite_Popups_Admin_Functions', 'initialize_popup_stats_daily'), 10 ,2 );
add_action( 'setup_popup_email_stats_cron', 				array('WPsite_Popups_Admin_Functions', 'setup_popup_email_stats'), 10 ,2 );
add_action( 'purge_popup_transients_cron', 					array('WPsite_Popups_Admin_Functions', 'purge_popup_transients'), 10 ,2);

// Miscellaneous

add_action( 'wp_ajax_wps_pf_send_weekly_email', 			array('WPsite_Popups_Admin_Functions', 'send_weekly_email'));

/**
 *
 * Main class for all admin functions
 *
 * @since 1.1.2
 */
class WPsite_Popups_Admin_Functions {

	/**
	 * Return a default popup
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_popup() {
		return array(
			'id' 			=> '',
			'name' 			=> '',
			'title' 		=> __('Popup Fire', WPsite_Popup::$text_domain),
			'text' 			=> __('Create Popups that display the right message at the right time', WPsite_Popup::$text_domain),
			'image' 		=> '',
			'social' => array(
				'link_type'		=> 'flat',
				'icons'			=> array(
					array('type' => 'fa-facebook', 'url' => 'https://www.facebook.com/WPsite'),
					array('type' => 'fa-google-plus', 'url' => 'https://plus.google.com/106771475441130344412/posts'),
					array('type' => 'fa-twitter', 'url' => 'https://twitter.com/WPsite'),
					array('type' => 'fa-linkedin', 'url' => 'http://linkedin.com/company/wpsite'),
					array('type' => 'fa-youtube', 'url' => 'http://youtube.com/wpsitenet/'),
					array('type' => 'fa-reddit', 'url' => 'http://reddit.com/u/wpsite'),
					array('type' => 'fa-instagram', 'url' => 'http://instagram.com/wpsite'),
					array('type' => 'fa-pinterest', 'url' => 'http://pinterest.com/wpsite/'),
				),
			),
			'news_letter' 	=> array(
				'type' 						=> 'WordPress',
				'first_name_placeholder'	=> __('First Name', WPsite_Popup::$text_domain),
				'last_name_placeholder'		=> __('Last Name', WPsite_Popup::$text_domain),
				'email_placeholder'			=> __('Email', WPsite_Popup::$text_domain),
				'first_name'				=> true,
				'last_name'					=> true,
				'button_text'				=> __('Subscribe', WPsite_Popup::$text_domain),
				'success_action'			=> 'message',
				'success_url'				=> '',
				'success_message'			=> __('We will be in touch soon!', WPsite_Popup::$text_domain),
				'MailChimp' => array(
					'url' 		=> '',
					'api_key'	=> '',
					'list'		=> '',
					'optin'		=> true,
				),
				'aweber' => array(
					'consumer_key' 		=> '',
					'consumer_secret' 	=> '',
					'access_key' 		=> '',
					'access_secret' 	=> '',
					'account_id' 		=> '',
					'list_id' 			=> ''
				),
				'getresponse'	=> array(
					'api_key' 		=> '',
					'campaign'		=> '',
				),
				'campaignmonitor'	=> array(
					'api_key'			=> '',
					'client' 			=> '',
					'list'				=> '',
				),
				'madmimi'	=> array(
					'api_key'			=> '',
					'username' 			=> '',
					'list'				=> '',
				),
				'infusionsoft'	=> array(
					'app_id'			=> '',
					'api_key' 			=> '',
					'list'				=> '',
				),
				'mymail' 	=> array(
					'list'		=> '',
				),
				'activecampaign' 	=> array(
					'api_url'	=> '',
					'api_key'	=> '',
					'list'		=> '',
				),
				'feedburner' 	=> array(
					'id'		=> ''
				)
			),
			'custom' 		=> '',
			'template' 		=> array(
				'type'		=> '3',
				'args'		=> array(
					'call_to_action'		=> 'newsletter',
					'footer'				=> __('We promise never to spam or share your information.', WPsite_Popup::$text_domain),
					'footer_icon'			=> 'fa-lock',
					'subscribe_icon'		=> 'fa-envelope',
					'subscribe_icon_place'	=> 'before',
					'contact_icon'			=> 'fa-envelope',
					'contact_icon_place'	=> 'before',
					'link_type' 			=> 'button',
					'link_target' 			=> '_blank',
					'link_rel' 				=> true,
					'link_url' 				=> 'https://99robots.com',
					'link_name' 			=> 'Click Here!',
					'link_text_color'		=> '#ffffff',
					'link_button_color'		=> '#4FC000',
					'video_type'			=> 'youtube',
					'video_url'				=> 'http://vimeo.com/108650530',
					'yes_text' 				=> __('YES', WPsite_Popup::$text_domain),
					'yes_sub_text' 			=> __("let's do this.", WPsite_Popup::$text_domain),
					'yes_link_target' 		=> '_blank',
					'yes_link_rel' 			=> true,
					'yes_link_url' 			=> 'https://99robots.com',
					'no_text' 				=> __('NO', WPsite_Popup::$text_domain),
					'no_sub_text' 			=> __("let's consider it gone.", WPsite_Popup::$text_domain),
					'no_link_target' 		=> '_blank',
					'no_link_rel' 			=> true,
					'no_link_url' 			=> 'https://99robots.com',
					'list'					=>  array(
						'color'			=> '#000000',
						'items'			=> array(
							array('icon' => 'fa-envelope', 'text' => __('Increase signups', WPsite_Popup::$text_domain)),
							array('icon' => 'fa-line-chart', 'text' => __('Drive more traffic', WPsite_Popup::$text_domain)),
							array('icon' => 'fa-crosshairs', 'text' => __('Create targeted call to action', WPsite_Popup::$text_domain)),
							array('icon' => 'fa-comment-o', 'text' => __('Display the right message at the right time', WPsite_Popup::$text_domain)),
							array('icon' => 'fa-group', 'text' => __('Show your content to the correct audience', WPsite_Popup::$text_domain)),
						),
					),
					'contact_us'  => array(
						'email_placeholder'			=> __('Email', WPsite_Popup::$text_domain),
						'subject_placeholder'		=> __('Subject', WPsite_Popup::$text_domain),
						'message_placeholder'		=> __('Message', WPsite_Popup::$text_domain),
						'button_text'				=> __('Contact Us', WPsite_Popup::$text_domain),
						'email'						=> get_bloginfo('admin_email'),
					),
				),
			),
			'trigger' 		=> array(
				'display_on'	=> 'site',
				'args'			=> array(
					'type'			=> 'timer',
					'timer' 		=> '0',
					'scroll' 		=> '75',
					'users'			=> 'any',
					'user_roles'	=> array(),
					'referrer_type'	=> 'any',
					'referrer'		=> 't.co,www.facebook.com,plus.url.google.com,www.linkedin.com',
				),
			),
			'style'			=> array(
				'background_type'		=> 'pattern',
				'background_image'		=> '',
				'background_color' 		=> '#ffffff',
				'background_pattern'	=> 'grid',
				'color' 				=> '#333333',
				'border_color' 			=> '#4FC000',
				'accent_color'			=> '#5bc0de',
				'button_shape'			=> 'rounded',
				'social_color' 			=> '#4FC000',
				'nl_color' 				=> '#ffffff',
				'nl_bg_color' 			=> '#4FC000',
				'cu_color' 				=> '#ffffff',
				'cu_bg_color' 			=> '#4FC000',
				'yes_color' 			=> '#ffffff',
				'yes_bg_color' 			=> '#4FC000',
				'no_color' 				=> '#ffffff',
				'no_bg_color' 			=> '#d9534f',
				'font_size'				=> 'auto',
				'font_weight'			=> 'normal',
				'google_fonts'			=> false,
				'font_family_heading'	=> 'Arial, Helvetica, sans-serif',
				'font_family'			=> 'Arial, Helvetica, sans-serif',
				'custom_css'			=> '',
			),
			'active' 		=> 'Active',
			'args'			=> array(
				'start_date'		=> null,
				'end_date'			=> null,
				'mobile'			=> 'yes',
				'dismiss'			=> '1440',
				'dont_show_again'	=> false,
				'powered_by'	=> 'yes',
				'ab_testing'	=> array(
					'active'	=> false,
					'popup_id'	=> '',
				)
			)
		);
	}

	/**
	 * Default settings for all optin fires
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_global_settings() {
		return array(
			'send_weekly_email'	=> true,
		);
	}

	/**
	 * Get all the data into an array format to save to the DB
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function save_data() {

		global $wp_roles;

		$post_types = get_post_types(array('public' => true));

		$default_popup = self::default_popup();

		$val['name']                                      = stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'name']));

		$val['title']                                     = isset($_POST[WPsite_Popup::$prefix_dash . 'title']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'title'])) :
															$default_popup['title'];

		$val['text']                                      = isset($_POST[WPsite_Popup::$prefix_dash . 'text']) ?
															stripslashes($_POST[WPsite_Popup::$prefix_dash . 'text']) :
															$default_popup['text'];

		$val['image']                                     = isset($_POST[WPsite_Popup::$prefix_dash . 'image']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'image']) :
															$default_popup['image'];

		$val['active']                                    = isset($_POST[WPsite_Popup::$prefix_dash . 'active']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'active'] :
															$default_popup['active'];

		// Template

		$val['template']['type']                          = isset($_POST[WPsite_Popup::$prefix_dash . 'template-type']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-type'] :
															$default_popup['template']['type'];

		$val['template']['args']['call_to_action']        = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-call-to-action']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-call-to-action'] :
															$default_popup['template']['args']['call_to_action'];

		$val['template']['args']['footer']                = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-footer']) ?
															stripcslashes($_POST[WPsite_Popup::$prefix_dash . 'template-args-footer']) :
															$default_popup['template']['args']['footer'];

		$val['template']['args']['footer_icon']           = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-footer-icon']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-footer-icon'] :
															$default_popup['template']['args']['footer_icon'];

		$val['template']['args']['subscribe_icon']        = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-subscribe-icon']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-subscribe-icon'] :
															$default_popup['template']['args']['subscribe_icon'];

		$val['template']['args']['subscribe_icon_place']  = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-subscribe-icon-place']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-subscribe-icon-place'] :
															$default_popup['template']['args']['subscribe_icon_place'];

		$val['template']['args']['contact_icon']          = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-contact-icon']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-contact-icon'] :
															$default_popup['template']['args']['contact_icon'];

		$val['template']['args']['contact_icon_place']    = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-contact-icon-place']) ?
															$_POST[WPsite_Popup::$prefix_dash . 'template-args-contact-icon-place'] :
															$default_popup['template']['args']['contact_icon_place'];

		$val['template']['args']['link_type']             = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-type']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-type']) :
															$default_popup['template']['args']['link_type'];

		$val['template']['args']['link_target']           = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-target']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-target']) :
															$default_popup['template']['args']['link_target'];

		$val['template']['args']['link_rel']              = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-rel']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-rel']) :
															$default_popup['template']['args']['link_rel'];

		$val['template']['args']['link_url']              = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-url']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-url']) :
															$default_popup['template']['args']['link_url'];

		$val['template']['args']['link_name']             = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-name']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-name'])) :
															$default_popup['template']['args']['link_name'];

		$val['template']['args']['link_text_color']       = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-text-color']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-text-color']) :
															$default_popup['template']['args']['link_text_color'];

		$val['template']['args']['link_button_color']     = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-button-color']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-link-button-color']) :
															$default_popup['template']['args']['link_button_color'];

		$val['template']['args']['video_type']            = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-video-type']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-video-type']) :
															$default_popup['template']['args']['video_type'];

		$val['template']['args']['video_url']             = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-video-url']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-video-url']) :
															$default_popup['template']['args']['video_url'];

		$val['template']['args']['yes_text']              = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-text']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-text'])) :
															$default_popup['template']['args']['yes_text'];

		$val['template']['args']['yes_sub_text']          = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-sub-text']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-sub-text'])) :
															$default_popup['template']['args']['yes_sub_text'];

		$val['template']['args']['yes_link_target']       = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-target']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-target']) :
															$default_popup['template']['args']['yes_link_target'];

		$val['template']['args']['yes_link_rel']          = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-rel']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-rel']) :
															$default_popup['template']['args']['yes_link_rel'];

		$val['template']['args']['yes_link_url']          = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-url']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-yes-link-url']) :
															$default_popup['template']['args']['yes_link_url'];

		$val['template']['args']['no_text']               = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-text']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-text'])) :
															$default_popup['template']['args']['no_text'];

		$val['template']['args']['no_sub_text']           = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-sub-text']) ?
															stripslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-sub-text'])) :
															$default_popup['template']['args']['no_sub_text'];

		$val['template']['args']['no_link_target']        = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-target']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-target']) :
															$default_popup['template']['args']['no_link_target'];

		$val['template']['args']['no_link_rel']           = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-rel']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-rel']) :
															$default_popup['template']['args']['no_link_rel'];

		$val['template']['args']['no_link_url']           = isset($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-url']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'template-args-no-link-url']) :
															$default_popup['template']['args']['no_link_url'];

		// Contact Us

		$val['template']['args']['contact_us']['email_placeholder']   = isset($_POST[WPsite_Popup::$prefix_dash . 'contact-us-email-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'contact-us-email-placeholder'])) :
																		$default_popup['template']['args']['contact_us']['email_placeholder'];

		$val['template']['args']['contact_us']['subject_placeholder'] = isset($_POST[WPsite_Popup::$prefix_dash . 'contact-us-subject-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'contact-us-subject-placeholder'])) :
																		$default_popup['template']['args']['contact_us']['subject_placeholder'];

		$val['template']['args']['contact_us']['message_placeholder'] = isset($_POST[WPsite_Popup::$prefix_dash . 'contact-us-message-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'contact-us-message-placeholder'])) :
																		$default_popup['template']['args']['contact_us']['message_placeholder'];

		$val['template']['args']['contact_us']['button_text']         = isset($_POST[WPsite_Popup::$prefix_dash . 'contact-us-button-text']) ?
																		stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'contact-us-button-text'])) :
																		$default_popup['template']['args']['contact_us']['button_text'];

		$val['template']['args']['contact_us']['email']               = isset($_POST[WPsite_Popup::$prefix_dash . 'contact-us-email']) ?
																		sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'contact-us-email']) :
																		$default_popup['template']['args']['contact_us']['email'];


		// Args

		$val['args']['mobile']                            = isset($_POST[WPsite_Popup::$prefix_dash . 'mobile']) &&
															$_POST[WPsite_Popup::$prefix_dash . 'mobile'] ? 'yes' : 'no';

		$val['args']['start_date']                        = isset($_POST[WPsite_Popup::$prefix_dash . 'start-date']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'start-date']) :
															date("m/d/Y");

		$val['args']['end_date']                          = isset($_POST[WPsite_Popup::$prefix_dash . 'end-date']) ?
															sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'end-date']) :
															date("m/d/Y", mktime(0, 0, 0, date("m"), date("d"), date("Y")+20));

		// Turn off caching ever time user changes this setting

		if (isset($_POST['args-dismiss']) && isset($val['args']['dismiss']) && $val['args']['dismiss'] != $_POST['args-dismiss']) {
			delete_transient(WPsite_Popup::$prefix . 'dismiss' . $_SERVER['REMOTE_ADDR']);
		}

		$val['args']['dismiss']                   = isset($_POST[WPsite_Popup::$prefix_dash . 'args-dismiss']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'args-dismiss'] :
													$default_popup['args']['dismiss'];

		$val['args']['dont_show_again']           = isset($_POST[WPsite_Popup::$prefix_dash . 'dont-show-again']) &&
													$_POST[WPsite_Popup::$prefix_dash . 'dont-show-again'] ? true : false;

		$val['args']['powered_by']                = isset($_POST[WPsite_Popup::$prefix_dash . 'powered-by']) &&
													$_POST[WPsite_Popup::$prefix_dash . 'powered-by'] ? 'yes' : 'no';

		$val['args']['ab_testing']['active']      = isset($_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-active']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-active'] : false;

		$val['args']['ab_testing']['popup_id']    = isset($_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-popup-id']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-popup-id'] : false;

		$val['args']['ab_testing']['start_date']  = isset($_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-start-date']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'args-ab-testing-start-date'] : false;


		// Style

		$val['style']['background_type']          = isset($_POST[WPsite_Popup::$prefix_dash . 'background-type']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'background-type']) :
													$default_popup['style']['background_type'];

		$val['style']['background_image']         = isset($_POST[WPsite_Popup::$prefix_dash . 'background-image']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'background-image']) :
													$default_popup['style']['background_image'];

		$val['style']['background_color']         = isset($_POST[WPsite_Popup::$prefix_dash . 'background-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'background-color']) :
													$default_popup['style']['background_color'];

		$val['style']['background_pattern']       = isset($_POST[WPsite_Popup::$prefix_dash . 'background-pattern']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'background-pattern']) :
													$default_popup['style']['background_pattern'];

		$val['style']['color']                    = isset($_POST[WPsite_Popup::$prefix_dash . 'color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'color']) :
													$default_popup['style']['color'];

		$val['style']['border_color']             = isset($_POST[WPsite_Popup::$prefix_dash . 'border-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'border-color']) :
													$default_popup['style']['border_color'];

		$val['style']['accent_color']             = isset($_POST[WPsite_Popup::$prefix_dash . 'accent-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'accent-color']) :
													$default_popup['style']['accent_color'];

		$val['style']['button_shape']             = isset($_POST[WPsite_Popup::$prefix_dash . 'button-shape']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'button-shape']) :
													$default_popup['style']['button_shape'];

		$val['style']['social_color']             = isset($_POST[WPsite_Popup::$prefix_dash . 'social-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'social-color']) :
													$default_popup['style']['social_color'];

		$val['style']['nl_color']                 = isset($_POST[WPsite_Popup::$prefix_dash . 'nl-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'nl-color']) :
													$default_popup['style']['nl_color'];

		$val['style']['nl_bg_color']              = isset($_POST[WPsite_Popup::$prefix_dash . 'nl-bg-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'nl-bg-color']) :
													$default_popup['style']['nl_bg_color'];

		$val['style']['cu_color']                 = isset($_POST[WPsite_Popup::$prefix_dash . 'cu-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'cu-color']) :
													$default_popup['style']['cu_color'];

		$val['style']['cu_bg_color']              = isset($_POST[WPsite_Popup::$prefix_dash . 'cu-bg-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'cu-bg-color']) :
													$default_popup['style']['cu_bg_color'];

		$val['style']['yes_color']                = isset($_POST[WPsite_Popup::$prefix_dash . 'yes-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'yes-color']) :
													$default_popup['style']['yes_color'];

		$val['style']['yes_bg_color']             = isset($_POST[WPsite_Popup::$prefix_dash . 'yes-bg-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'yes-bg-color']) :
													$default_popup['style']['yes_bg_color'];

		$val['style']['no_color']                 = isset($_POST[WPsite_Popup::$prefix_dash . 'no-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'no-color']) :
													$default_popup['style']['no_color'];

		$val['style']['no_bg_color']              = isset($_POST[WPsite_Popup::$prefix_dash . 'no-bg-color']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'no-bg-color']) :
													$default_popup['style']['no_bg_color'];

		$val['style']['font_size']                = isset($_POST[WPsite_Popup::$prefix_dash . 'font-size']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'font-size']) :
													$default_popup['style']['font_size'];

		$val['style']['font_weight']              = isset($_POST[WPsite_Popup::$prefix_dash . 'font-weight']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'font-weight']) :
													$default_popup['style']['font_weight'];

		$val['style']['google_fonts']             = isset($_POST[WPsite_Popup::$prefix_dash . 'google-fonts']) &&
													$_POST[WPsite_Popup::$prefix_dash . 'google-fonts'] ? true : false;

		$val['style']['font_family_heading']      = isset($_POST[WPsite_Popup::$prefix_dash . 'font-family-heading']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'font-family-heading']) :
													$default_popup['style']['font_family_heading'];

		$val['style']['font_family']              = isset($_POST[WPsite_Popup::$prefix_dash . 'font-family']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'font-family']) :
													$default_popup['style']['font_family'];

		$val['style']['custom_css']               = isset($_POST[WPsite_Popup::$prefix_dash . 'custom-css']) ?
													stripcslashes($_POST[WPsite_Popup::$prefix_dash . 'custom-css']) :
													$default_popup['style']['custom_css'];


		// Trigger

		$val['trigger']['display_on']          	  = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-display-on']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'trigger-display-on'] :
													$default_popup['trigger']['display_on'];

		$val['trigger']['args']['type']           = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-type']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'trigger-args-type'] :
													$default_popup['trigger']['args']['type'];

		$val['trigger']['args']['timer']          = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-timer']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-timer']) :
													$default_popup['trigger']['args']['timer'];

		$val['trigger']['args']['scroll']         = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-scroll']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-scroll']) :
													$default_popup['trigger']['args']['scroll'];

		$val['trigger']['args']['users']          = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-users']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-users']) :
													$default_popup['trigger']['args']['users'];

		// User roles

		foreach ($wp_roles->role_names as $role_name => $role) {
			$val['trigger']['args']['user_roles'][$role_name] = isset($_POST[WPsite_Popup::$prefix_dash . 'args-role-' . $role_name]) && $_POST[WPsite_Popup::$prefix_dash . 'args-role-' . $role_name] ? true : false;
		}

		$val['trigger']['args']['referrer_type']  = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-referrer-type']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-referrer-type']) :
													$default_popup['trigger']['args']['referrer_type'];

		$val['trigger']['args']['referrer']       = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-referrer']) ?
													sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-args-referrer']) :
													$default_popup['trigger']['args']['referrer'];

		$val['trigger']['category']['all']        = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-category-all']) ?
													$_POST[WPsite_Popup::$prefix_dash . 'trigger-category-all'] :
													$default_popup['trigger']['category']['all'];

		$val['trigger']['category']['id']         = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-category-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-category-id']), ',')) :
													$default_popup['trigger']['args']['id'];

		$val['trigger']['tag']['id']              = isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-tag-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-tag-id']), ',')) :
													$default_popup['trigger']['tag']['id'];

		// Post Types

		foreach ($post_types as $post_type) {
			$val['trigger'][$post_type]['all']		= isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-all-' . $post_type]) &&
													  $_POST[WPsite_Popup::$prefix_dash . 'trigger-all-' . $post_type] ? true : false;

			$val['trigger'][$post_type]['id'] 		= isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-id-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-id-' . $post_type]), ',')) : '';
			$val['trigger'][$post_type]['exclude'] 	= isset($_POST[WPsite_Popup::$prefix_dash . 'trigger-exclude-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'trigger-exclude-' . $post_type]), ',')) : '';
		}

		// Social Icons

		$val['social']['link_type'] 				= isset($_POST[WPsite_Popup::$prefix_dash . 'social-link-type']) ?
													  sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'social-link-type']) :
													  $default_popup['social']['link_type'];

		$social_type = isset($_POST[WPsite_Popup::$prefix_dash . 'social-type']) ? $_POST[WPsite_Popup::$prefix_dash . 'social-type'] : '';
		$social_url = isset($_POST[WPsite_Popup::$prefix_dash . 'social-url']) ? $_POST[WPsite_Popup::$prefix_dash . 'social-url'] : '';

		$social_media_icons = array();

		for ($i = 0; $i < count($social_type); $i++) {

			if (isset($social_type[$i]) && $social_type[$i] != '' && $social_url[$i] != '') {
				$social_media_icons[] = array(
					'type' 	=> sanitize_text_field($social_type[$i]),
					'url' 	=> sanitize_text_field($social_url[$i])
				);
			}
		}

		$val['social']['icons'] = $social_media_icons;

		// List Items

		$val['template']['args']['list']['color'] 	= isset($_POST[WPsite_Popup::$prefix_dash . 'list-color']) ?
													  sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'list-color']) :
													  $default_popup['template']['args']['list']['color'];

		$list_text = isset($_POST[WPsite_Popup::$prefix_dash . 'list-text']) ? $_POST[WPsite_Popup::$prefix_dash . 'list-text'] : '';
		$list_icon = isset($_POST[WPsite_Popup::$prefix_dash . 'list-icon']) ? $_POST[WPsite_Popup::$prefix_dash . 'list-icon'] : '';

		$list_items = array();

		for ($i = 0; $i < count($list_text); $i++) {

			if (isset($list_text[$i]) && $list_text[$i] != '' && $list_icon[$i] != '') {
				$list_items[] = array(
					'icon' 	=> sanitize_text_field($list_icon[$i]),
					'text' 	=> stripslashes(sanitize_text_field($list_text[$i]))
				);
			}
		}

		$val['template']['args']['list']['items'] = $list_items;

		// News Letter

		$val['news_letter']['type']                               = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-type']) ?
																	$_POST[WPsite_Popup::$prefix_dash . 'news-letter-type'] :
																	$default_popup['news_letter']['type'];

		$val['news_letter']['first_name']                         = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-first-name']) &&
																	$_POST[WPsite_Popup::$prefix_dash . 'news-letter-first-name'] ? true : false;

		$val['news_letter']['last_name']                          = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-last-name']) &&
																	$_POST[WPsite_Popup::$prefix_dash . 'news-letter-last-name'] ? true : false;

		$val['news_letter']['first_name_placeholder']             = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-first-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-first-name-placeholder'])) :
																	$default_popup['news_letter']['first_name_placeholder'];

		$val['news_letter']['last_name_placeholder']              = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-last-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-last-name-placeholder'])) :
																	$default_popup['news_letter']['last_name_placeholder'];

		$val['news_letter']['email_placeholder']                  = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-email-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-email-placeholder'])) :
																	$default_popup['news_letter']['email_placeholder'];

		$val['news_letter']['success_action']            		  = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-action']) ?
																	$_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-action'] :
																	$default_popup['news_letter']['success_action'];

		$val['news_letter']['success_url']            		      = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-url']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-url']) :
																	$default_popup['news_letter']['success_url'];

		$val['news_letter']['success_message']            		  = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-message']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-success-message']) :
																	$default_popup['news_letter']['success_message'];

		$val['news_letter']['button_text']            		      = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-button-text']) ?
																 	stripcslashes(sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-button-text'])) :
																	$default_popup['news_letter']['button_text'];

		// MailChimp

		$val['news_letter']['MailChimp']['url']                   = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-url']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-url']) :
																	$default_popup['news_letter']['MailChimp']['url'];

		$val['news_letter']['MailChimp']['api_key']               = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-api-key']) :
																	$default_popup['news_letter']['MailChimp']['api_key'];

		$val['news_letter']['MailChimp']['list']                  = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-list']) :
																	$default_popup['news_letter']['MailChimp']['list'];

		$val['news_letter']['MailChimp']['optin']                 = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-optin']) &&
																	$_POST[WPsite_Popup::$prefix_dash . 'news-letter-MailChimp-optin'] ? true : false;

		// aweber

		$val['news_letter']['aweber']['consumer_key']             = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-consumer-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-consumer-key']) :
																	$default_popup['news_letter']['aweber']['consumer_key'];

		$val['news_letter']['aweber']['consumer_secret']          = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-consumer-secret']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-consumer-secret']) :
																	$default_popup['news_letter']['aweber']['consumer_secret'];

		$val['news_letter']['aweber']['access_key']               = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-access-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-access-key']) :
																	$default_popup['news_letter']['aweber']['access_key'];

		$val['news_letter']['aweber']['access_secret']            = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-access-secret']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-access-secret']) :
																	$default_popup['news_letter']['aweber']['access_secret'];

		$val['news_letter']['aweber']['account_id']               = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-account-id']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-account-id']) :
																	$default_popup['news_letter']['aweber']['account_id'];

		$val['news_letter']['aweber']['list_id']                  = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-list-id']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-aweber-list-id']) :
																	$default_popup['news_letter']['aweber']['list_id'];

		// Get Response

		$val['news_letter']['getresponse']['api_key']             = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-getresponse-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-getresponse-api-key']) :
																	$default_popup['news_letter']['getresponse']['api_key'];

		$val['news_letter']['getresponse']['campaign']            = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-getresponse-campaign']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-getresponse-campaign']) :
																	$default_popup['news_letter']['getresponse']['campaign'];

		// Campiagn Monitor

		$val['news_letter']['campaignmonitor']['api_key']         = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-api-key']) :
																	$default_popup['news_letter']['campaignmonitor']['api_key'];

		$val['news_letter']['campaignmonitor']['client']          = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-client']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-client']) :
																	$default_popup['news_letter']['campaignmonitor']['client'];

		$val['news_letter']['campaignmonitor']['list']            = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-campaignmonitor-list']) :
																	$default_popup['news_letter']['campaignmonitor']['list'];

		// Mad Mimi

		$val['news_letter']['madmimi']['api_key']                 = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-api-key']) :
																	$default_popup['news_letter']['madmimi']['api_key'];

		$val['news_letter']['madmimi']['username']                = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-username']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-username']) :
																	$default_popup['news_letter']['madmimi']['username'];

		$val['news_letter']['madmimi']['list']                    = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-madmimi-list']) :
																	$default_popup['news_letter']['madmimi']['list'];

		// Infusion Soft

		$val['news_letter']['infusionsoft']['app_id']             = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-app-id']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-app-id']) :
																	$default_popup['news_letter']['infusionsoft']['app_id'];

		$val['news_letter']['infusionsoft']['api_key']            = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-api-key']) :
																	$default_popup['news_letter']['infusionsoft']['api_key'];

		$val['news_letter']['infusionsoft']['list']               = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-infusionsoft-list']) :
																	$default_popup['news_letter']['infusionsoft']['list'];

		// MyMail

		$val['news_letter']['mymail']['list']                     = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-mymail-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-mymail-list']) :
																	$default_popup['mymail']['list'];

		// Active Campaign

		$val['news_letter']['activecampaign']['app_url']          = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-app-url']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-app-url']) :
																	$default_popup['news_letter']['activecampaign']['app_url'];

		$val['news_letter']['activecampaign']['api_key']          = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-api-key']) :
																	$default_popup['news_letter']['activecampaign']['api_key'];

		$val['news_letter']['activecampaign']['list']             = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-list']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-activecampaign-list']) :
																	$default_popup['news_letter']['activecampaign']['list'];

		// feedburner

		$val['news_letter']['feedburner']['id']                   = isset($_POST[WPsite_Popup::$prefix_dash . 'news-letter-feedburner-id']) ?
																	sanitize_text_field($_POST[WPsite_Popup::$prefix_dash . 'news-letter-feedburner-id']) :
																	$default_popup['aweber']['feedburner']['id'];

		// Custom

		$val['custom']                                            = isset($_POST[WPsite_Popup::$prefix_dash . 'custom']) ?
																	stripcslashes($_POST[WPsite_Popup::$prefix_dash . 'custom']) :
																	$default_popup['custom'];

		return $val;
	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		include_once(WPSITE_POPUP_PLUGIN_DIR . "core/model/stats.php");
		include_once(WPSITE_POPUP_PLUGIN_DIR . "admin/model/db.php");

		// Get Start and End Dates

		$start_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All popup stats

		if (!isset($_GET['action']) && isset($_POST['popup_name']) && $_POST['popup_name'] == '') {

			$stats = WPsite_Stats_PF::getStats($start_date, $end_date);

			$popups = $wpdb->get_results("SELECT * FROM `" . WPsite_Popup_DB::getTableName() . "`");

			$popup_stats = array();

			foreach ($popups as $popup) {
				foreach ($stats as $stat) {
					if ($popup->id == $stat['popup_id']) {
						$popup_stats[$popup->id] = array(
							'popup_id'	=> $stat['popup_id'],
							'popup_name'	=> $popup->name,
							'popup_type'	=> $popup->template,
							'date'			=> $stat['date'],
							'impressions'	=> isset($popup_stats[$popup->id]['impressions']) ? $popup_stats[$popup->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
							'clicks'	=> isset($popup_stats[$popup->id]['clicks']) ? $popup_stats[$popup->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
						);
					}
				}
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($popup_stats as $popup_stat) {
			    $impressions_total += $popup_stat['impressions'];
			    $conversions_total += $popup_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Popup::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . WPsite_Popup::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . WPsite_Popup::$prefix_dash . 'line-graph-container">
				<canvas id="' . WPsite_Popup::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped sortable">

					<thead>
						<th>' . __('Popup', WPsite_Popup::$text_domain) . '</th>
						<th class="' . WPsite_Popup::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', WPsite_Popup::$text_domain) . '</th>
						<th class="' . WPsite_Popup::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', WPsite_Popup::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . WPsite_Popup::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', WPsite_Popup::$text_domain) . '</th>
					</thead>';

					foreach ($popup_stats as $popup_stat) {

						$stats_content .= '<tr>
							<td>
								<a href="' . admin_url() . 'admin.php?page=' . WPsite_Popup::$stats_page . '&popup_id=' . $popup_stat['popup_id'] . '&popup_name=' . $popup_stat['popup_name'] . '" role="button" class="btn btn-xs btn-primary">
									' .  $popup_stat['popup_name'] . '
								</a>
							</td>
							<td>' . number_format($popup_stat['impressions']) . '</td>';
							$stats_content .= '
							<td>' . number_format($popup_stat['clicks']) . '</td>
							<td>' . ($popup_stat['impressions'] > 0 ? round(($popup_stat['clicks'] / $popup_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// Single popup stats

		else if ($_POST['ab_action'] == '' && isset($_POST['popup_name']) && $_POST['popup_name'] != '') {

			$popup_stats = WPsite_Stats_PF::getStats($start_date, $end_date, $_POST['popup_id']);

			$popups = $wpdb->get_results("SELECT * FROM `" . WPsite_Popup_DB::getTableName() . "`");

			foreach ($popups as $popup) {
				foreach ($popup_stats as $key => $popup_stat) {
					if ($popup->id == $popup_stat['popup_id']) {
						$popup_stats[$key] = array('popup_name' => $popup->name) + $popup_stats[$key] + array('popup_type' => $popup->template);
					}
				}
			}

			// Unset indexs

			foreach ($popup_stats as $key => $popup_stat) {
				unset($popup_stats[$key]['id']);
				unset($popup_stats[$key]['popup_id']);
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($popup_stats as $popup_stat) {
			    $impressions_total += $popup_stat['impressions'];
			    $conversions_total += $popup_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Popup::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . WPsite_Popup::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . WPsite_Popup::$prefix_dash . 'line-graph-container">
				<canvas id="' . WPsite_Popup::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped sortable">

					<thead>
						<th>' . __('Date', WPsite_Popup::$text_domain) . '</th>
						<th class="' . WPsite_Popup::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Impressions', WPsite_Popup::$text_domain) . '</th>
						<th class="' . WPsite_Popup::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', WPsite_Popup::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . WPsite_Popup::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', WPsite_Popup::$text_domain) . '</th>
					</thead>';

					foreach (array_reverse($popup_stats) as $popup_stat) {

						$stats_content .= '<tr>
							<td>' . date('M j Y', strtotime($popup_stat['date'])) . '</td>
							<td>' . number_format($popup_stat['impressions']) . '</td>';
							$stats_content .= '
							<td>' . number_format($popup_stat['clicks']) . '</td>
							<td>' . ($popup_stat['impressions'] > 0 ? round(($popup_stat['clicks'] / $popup_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// A/B Test stats

		else if ($_POST['ab_action'] == 'ab-testing' && isset($_POST['popup_name']) && $_POST['popup_name'] != '') {

			$wpsite_popup_db = new WPsite_Popup_DB();

			$popup = $wpsite_popup_db->get_data_from_id($_POST['popup_id']);

			$popup['social']         = unserialize($popup['social']);
			$popup['news_letter']    = unserialize($popup['news_letter']);
			$popup['template']       = unserialize($popup['template']);
			$popup['trigger']        = unserialize($popup['trigger']);
			$popup['style']          = unserialize($popup['style']);
			$popup['args']           = unserialize($popup['args']);

			// Get Start and End Dates

			$start_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
			$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime(current_time('mysql')));

			$post_start_date = urldecode($_POST['start_date']);
			$post_end_date = urldecode($_POST['end_date']);

			if (isset($post_start_date) && $post_start_date != '') {
				$start_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_start_date));
			}

			if (isset($post_end_date) && $post_end_date != '') {
				$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_end_date));
			}

			// Check for A/B Test Start Date

			if ( strtotime($post_start_date) < strtotime($popup['args']['ab_testing']['start_date']) ) {
				$start_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($popup['args']['ab_testing']['start_date']));
			}

			$popup_stats = WPsite_Stats_PF::getStats($start_date, $end_date, $_POST['popup_id']);
			$ab_popup_stats = WPsite_Stats_PF::getStats($start_date, $end_date, $popup['args']['ab_testing']['popup_id']);
			$popups = $wpdb->get_results("SELECT * FROM `" . WPsite_Popup_DB::getTableName() . "`");

			// Get stats array for popup

			foreach ($popups as $popup) {
				foreach ($popup_stats as $key => $popup_stat) {
					if ($popup->id == $popup_stat['popup_id']) {
						$popup_stats[$key] = array('popup_name' => $popup->name) + $popup_stats[$key] + array('popup_type' => $popup->template);
					}
				}
			}

			// Unset indexes

			foreach ($popup_stats as $key => $popup_stat) {
				unset($popup_stats[$key]['id']);
				unset($popup_stats[$key]['popup_id']);
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($popup_stats as $popup_stat) {
			    $impressions_total += $popup_stat['impressions'];
			    $conversions_total += $popup_stat['clicks'];
			}

			// Get stats array for ab popup

			foreach ($popups as $popup) {
				foreach ($ab_popup_stats as $key => $ab_popup_stat) {
					if ($popup->id == $ab_popup_stat['popup_id']) {
						$ab_popup_stats[$key] = array('popup_name' => $popup->name) + $ab_popup_stats[$key] + array('popup_type' => $popup->template);
					}
				}
			}

			// Unset indexes

			foreach ($ab_popup_stats as $key => $ab_popup_stat) {
				unset($ab_popup_stats[$key]['id']);
				unset($ab_popup_stats[$key]['popup_id']);
			}

			$ab_impressions_total = 0;
			$ab_clicks_total = 0;
			foreach ($ab_popup_stats as $ab_popup_stat) {
			    $ab_impressions_total += $ab_popup_stat['impressions'];
			    $ab_clicks_total += $ab_popup_stat['clicks'];
			}

			$ab_testing_stats = array(
				'popup_stats'		=> $popup_stats,
				'ab_popup_stats'	=> $ab_popup_stats,
			);

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;
			$ab_ctr = $impressions_total != 0 ? round(($ab_clicks_total/$ab_impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Popup::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . WPsite_Popup::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">A</div>' .
									number_format($impressions_total) .
								'</div>
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">B</div>' .
									number_format($ab_impressions_total) .
								'</div>
						</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">A</div>' .
									number_format($conversions_total) .
								'</div>
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">B</div>' .
									number_format($ab_clicks_total) .
								'</div>
						</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Popup::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', WPsite_Popup::$text_domain) . '</span>
						<div class="' . WPsite_Popup::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">A</div>' .
									$ctr . '%' .
								'</div>
							<div>
								<div class="'  . WPsite_Popup::$prefix_dash . 'stats-ab-indicator">B</div>' .
									$ab_ctr . '%' .
								'</div>
						</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="col-xs-6">
				<canvas id="' . WPsite_Popup::$prefix_dash . 'line-graph" style="width: 100%;"></canvas>
			</div>

			<div class="col-xs-6">
				<canvas id="' . WPsite_Popup::$prefix_dash . 'line-graph-ab" style="width: 100%;"></canvas>
			</div>';

			echo json_encode(array('stats_content' => $stats_content, 'stats' => $ab_testing_stats));

			die(); // this is required to terminate immediately and return a proper response

		}

		echo json_encode(array('stats_content' => $stats_content, 'popup_stats' => $popup_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails_load() {

		include_once(WPSITE_POPUP_PLUGIN_DIR . "core/model/email-signups.php");
		include_once(WPSITE_POPUP_PLUGIN_DIR . "admin/model/db.php");

		// Get Start and End Dates

		$start_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_end_date));
		}

		// Get Emails

		global $wpdb;

		$emails = WPsite_Email_Signups_PF::getEmails($start_date, $end_date);
		$popups = $wpdb->get_results("SELECT * FROM `" . WPsite_Popup_DB::getTableName() . "`");

		foreach ($emails as $key => $email) {
			$emails[$key]['popup_name'] = '<strong style="color:red;">DELETED</strong>';
		}

		foreach ($popups as $popup) {
			foreach ($emails as $key => $email) {
				if ($popup->id == $email['popup_id']) {
					$emails[$key] = array(
						'popup_id'		=> $email['popup_id'],
						'popup_name'	=> $popup->name,
						'date'			=> $email['date'],
						'email'			=> $email['email'],
						'first_name'	=> $email['first_name'],
						'last_name'		=> $email['last_name'],
					);
				}
			}
		}

		$emails_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<table class="table table-condensed table-striped">

				<thead>
					<th>' . __('Date', WPsite_Popup::$text_domain) . '</th>
					<th>' . __('Popup Name', WPsite_Popup::$text_domain) . '</th>
					<th>' . __('Email', WPsite_Popup::$text_domain) . '</th>
					<th>' . __('First Name', WPsite_Popup::$text_domain) . '</th>
					<th>' . __('Last Name', WPsite_Popup::$text_domain) . '</th>
				</thead>';

				if (count($emails) < 1) {
					$emails_content .= '<tr>
						<td>' . __('No emails yet', WPsite_Popup::$text_domain) . '</td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
					</tr>';
				} else {
					foreach (array_reverse($emails) as $popup_email) {

						$emails_content .= '<tr>
							<td>' . $popup_email['date'] . '</td>
							<td>' . $popup_email['popup_name'] . '</td>
							<td>' . $popup_email['email'] . '</td>
							<td>' . $popup_email['first_name'] . '</td>
							<td>' . $popup_email['last_name'] . '</td>
						</tr>';

					}
				}

			$emails_content .= '</table>
		</div>';

		echo $emails_content;

		die(); // this is required to terminate immediately and return a proper response
	}

			/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entries_load() {

		// Includes

		include_once(WPSITE_POPUP_PLUGIN_DIR . 'admin/model/db.php');
		include_once(WPSITE_POPUP_PLUGIN_DIR . 'core/model/email-entries.php');
		require_once(WPSITE_POPUP_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$db = new WPsite_Popup_DB();
		$popup_fires = $db->get_popups();

		$entries_content = '';

		// Get Start and End Dates

		$start_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(59, 59, 23, date("m"), date("d"), date("Y")));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {

			$temp_end_date = strtotime($post_end_date);

			$end_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(59, 59, 23, date("m", $temp_end_date), date("d", $temp_end_date), date("Y", $temp_end_date)));
		}

		// Get Entries

		global $wpdb;

		$entries = WPsite_Email_Entries_PF::getEntries($start_date, $end_date);

		foreach ($entries as $key => $email) {
			$entries[$key]['popup_fire_name'] = '<strong style="color:red;">' . __('DELETED', WPsite_Popup::$text_domain) . '</strong>';
		}

		foreach ($popup_fires as $popup_fire) {
			foreach ($entries as $key => $entry) {
				if ($popup_fire['id'] == $entry['popup_id']) {
					$entries[$key]['popup_fire_name'] = $popup_fire['name'];
				}
			}
		}

		$now = new DateTime();

		if (count($entries) < 1) {
			$entries_content .= '<tr>
				<td>' . __('No entries found', WPsite_Popup::$text_domain) . '</td>
			</tr>';
		} else {

		$entries_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<div class="col-xs-4 ' . WPsite_Popup::$prefix_dash . 'entry-list">
				<table class="table table-condensed table-hover">';


						foreach (array_reverse($entries) as $entry) {

							if ( !isset($entry_id) ) {
								$entry_id = $entry['id'];
							}

							$dateTime = new DateTime($entry['date']);

							$message = $entry['message'];

							if ( strlen($message) > 100 ) {
								$message = substr($message, 0, 50) . ' ...';
							}

							$entries_content .= '<tr class="' . WPsite_Popup::$prefix_dash . 'entry-row" data-entry-id="' . $entry['id'] . '">
								<td>
									<div class="col-xs-12">
										<span class="' . WPsite_Popup::$prefix_dash . 'entry-email pull-left">' . $entry['email'] . '</span>
										<span class="' . WPsite_Popup::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span>
									</div>
									<div class="col-xs-12">
										<span class="' . WPsite_Popup::$prefix_dash . 'entry-subject pull-left">' . $entry['subject'] . '</span>
										<span class="' . WPsite_Popup::$prefix_dash . 'entry-optin pull-right">' . $entry['popup_fire_name'] . '</span>
									</div>
									<div class="col-xs-12">
										<p class="' . WPsite_Popup::$prefix_dash . 'entry-message"><em>' . $message . '</em></p>
									</div>
								</td>
							</tr>';

						}


			$entries_content .= '
				</table>
			</div>
			<div class="col-xs-8 ' . WPsite_Popup::$prefix_dash . 'single-entry" data-entry-id="' . $entry_id . '"></div>
		</div>';

		}

		echo $entries_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the data for a single entry
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entry_load() {

		// Check if their is an entry id

		if ( !isset($_POST['entry_id']) ) {
			echo '';
			die();
		}

		// Get Entry Data

		global $wpdb;

		$entry = WPsite_Email_Entries_PF::getEntry($_POST['entry_id']);
		$entry = $entry[0];

		require_once(WPSITE_POPUP_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$now = new DateTime();
		$dateTime = new DateTime($entry['date']);

		$entry_content = '<div class="' . WPsite_Popup::$prefix_dash . 'entry-container">

			<div class="' . WPsite_Popup::$prefix_dash . 'entry-header-data">
				<div class="' . WPsite_Popup::$prefix_dash . 'entry-info-email">' . $entry['email'] . '<span class="' . WPsite_Popup::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span></div>
				<div class="' . WPsite_Popup::$prefix_dash . 'entry-info-subject">' . $entry['subject'] . '</div>
			</div>

			<p class="' . WPsite_Popup::$prefix_dash . 'entry-info-message">' . $entry['message'] . '</p>

		</div>';

		echo $entry_content;

		die();

	}

	/**
	 * Everyday check if there is a record for impressions or clicks for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_popup_stats_daily() {

		include_once(WPSITE_POPUP_PLUGIN_DIR . "core/model/stats.php");

		WPsite_Stats_PF::initialize_popup_stats();
	}

	/**
	 * Deletes all transients that have expired
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function purge_popup_transients($older_than = '1 day', $safemode = true) {

		global $wpdb;
		$older_than_time = strtotime('-' . $older_than);

		/**
		 * Only check if the transients are older than the specified time
		 */

		if ( $older_than_time > time() || $older_than_time < 1 ) {
			return false;
		}

		/**
		 * Get all the expired transients
		 *
		 * @var mixed
		 * @access public
		 */
		$transients = $wpdb->get_col(
			$wpdb->prepare( "
					SELECT REPLACE(option_name, '_transient_timeout_', '') AS transient_name
					FROM {$wpdb->options}
					WHERE option_name LIKE '\_transient\_timeout\__%%'
						AND option_value < %s
			", $older_than_time)
		);

		/**
		 * If safemode is ON just use the default WordPress get_transient() function
		 * to delete the expired transients
		 */

		if ( $safemode ) {
			foreach( $transients as $transient ) {
				get_transient($transient);
			}
		}

		/**
		 * If safemode is OFF the just manually delete all the transient rows in the database
		 */

		else {
			$options_names = array();
			foreach($transients as $transient) {
				$options_names[] = '_transient_' . $transient;
				$options_names[] = '_transient_timeout_' . $transient;
			}
			if ($options_names) {
				$options_names = array_map(array($wpdb, 'escape'), $options_names);
				$options_names = "'". implode("','", $options_names) ."'";

				$result = $wpdb->query( "DELETE FROM {$wpdb->options} WHERE option_name IN ({$options_names})" );
				if (!$result) {
					return false;
				}
			}
		}

		return $transients;
	}

	/**
	 * Email the weekly Popup Stats to the admin account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function setup_popup_email_stats() {

		$global_settings = get_option(WPsite_Popup::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if (!$global_settings['send_weekly_email']) {
			return false;
		}

		// Comment this out for testing

		if (date('N') != 7) {
			return false;
		}

		include_once(WPSITE_POPUP_PLUGIN_DIR . "/core/model/stats.php");
		include_once(WPSITE_POPUP_PLUGIN_DIR . "/admin/model/db.php");

		global $wpdb;

		$admins = get_users('role=administrator');
		$start_date = date(WPSITE_POPUP_DATE_FORMAT, mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
		$end_date = date(WPSITE_POPUP_DATE_FORMAT, strtotime(current_time('mysql')));
		$stats = WPsite_Stats_PF::getStats($start_date, $end_date);
		$popups = $wpdb->get_results("SELECT * FROM `" . WPsite_Popup_DB::getTableName() . "`");
		$popup_stats = array();

		foreach ($popups as $popup) {
			foreach ($stats as $stat) {
				if ($popup->id == $stat['popup_id']) {
					$popup_stats[$popup->id] = array(
						'popup_id'		=> $stat['popup_id'],
						'popup_name'	=> $popup->name,
						'popup_type'	=> $popup->template,
						'date'			=> $stat['date'],
						'impressions'	=> isset($popup_stats[$popup->id]['impressions']) ? $popup_stats[$popup->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
						'clicks'		=> isset($popup_stats[$popup->id]['clicks']) ? $popup_stats[$popup->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
					);
				}
			}
		}

		$impressions_total = 0;
		$clicks_total = 0;

		foreach ($popup_stats as $popup_stat) {
		    $impressions_total += $popup_stat['impressions'];
		    $clicks_total += $popup_stat['clicks'];
		}

		$subject = __('Weekly Popup Stats!', WPsite_Popup::$text_domain);
		$head = '<html>
			<head></head>';
		$body = '<body>
				<img src="' . WPSITE_POPUP_PLUGIN_URL . '/img/rainbow-strip-hz-wide.png" style="width: 100%;"/>
				<h1>' . __('WPsite Popup Weekly Stats', WPsite_Popup::$text_domain) . '</h1>
				<h1>' . date('M j', strtotime($start_date)) . ' - ' . date('M j', strtotime($end_date)) . '</h1>
				<div style="min-height: 20px;
					  padding: 19px;
					  margin-bottom: 20px;
					  background-color: #f5f5f5;
					  border: 1px solid #e3e3e3;
					  border-radius: 4px;
					  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);
					          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);">
					<table style="width:100%; border: none;">
						<col width="33.33%">
						<col width="33.33%">
						<col width="33.33%">
						<thead style="border: none;">
							<th style="border: none;">' . __('Impressions', WPsite_Popup::$text_domain) . '</th>
							<th style="border: none;">' . __('Conversions', WPsite_Popup::$text_domain) . '</th>
							<th style="border: none;">' .  __('Conversion Rate', WPsite_Popup::$text_domain) . '</th>
						</thead>
						<tr style="border: none;">
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($impressions_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($clicks_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . round(($clicks_total/$impressions_total) * 100,2) . '%</td>
						</tr>
					</table>
				</div>
				<table style="width: 100%;
					max-width: 100%;
					margin-bottom: 20px;">
					<thead style="border: 1px solid #ddd;">
						<th style="vertical-align: bottom;
							border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('Popup', WPsite_Popup::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('Impressions', WPsite_Popup::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversions', WPsite_Popup::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversion Rate', WPsite_Popup::$text_domain) . '</th>
					</thead>';
					foreach ($popup_stats as $popup_stat) {
						$body .= '<tr style="border: 1px solid #ddd;text-align:center;">
							<td>
								<a style="
								  color: white;
								  text-decoration: none;
								  color: #fff;
								  cursor: pointer;
								display: inline-block;
								font-family: \'Helvetica Neue\', Helvetica, Arial, sans-serif;
								font-size: 12px;
								font-stretch: normal;
								font-style: normal;
								font-variant: normal;
								font-weight: normal;
								height: 18px;
								letter-spacing: normal;
								line-height: 18px;
								margin-bottom: 0px;
								margin-left: 0px;
								margin-right: 0px;
								margin-top: 0px;
								overflow-x: visible;
								overflow-y: visible;
								padding-bottom: 1px;
								padding-left: 5px;
								padding-right: 5px;
								padding-top: 1px;
								  background-color: #337ab7;
								  border-color: #2e6da4;
								  -webkit-border-radius: 3px;
								  -moz-border-radius: 3px;
								  border-radius: 3px;" href="' . admin_url() . 'admin.php?page=' . WPsite_Popup::$stats_page . '&popup_id=' . $popup_stat['popup_id'] . '&popup_name=' . $popup_stat['popup_name'] . '">
									' .  $popup_stat['popup_name'] . '
								</a>
							</td>
							<td>' . number_format($popup_stat['impressions']) . '</td>';
							if ($popup_stat['popup_type'] == 'Text') {
								$body .= '
								<td>' . __('N/A', WPsite_Popup::$text_domain) . '</td>
								<td>' . __('N/A', WPsite_Popup::$text_domain) . '</td>';
							} else {
								$body .= '
								<td>' . number_format($popup_stat['clicks']) . '</td>
								<td>' . ($popup_stat['impressions'] > 0 ? round(($popup_stat['clicks'] / $popup_stat['impressions']) * 100, 2) : '0') . '%</td>';
							}
						$body .= '</tr>';
					}
			$body .= '</table>
			</body>';
		$foot = '
			<br/>
			<br/>
			<br/>
			<p style="text-align: center;"><a href="https://99robots.com">' . __('Visit', WPsite_Popup::$text_domain) . '</a> ' . __('our site to read about all the latest WordPress News.', WPsite_Popup::$text_domain) . '</p>
		</html>';

		$message = $head . $body . $foot;

		$headers = array('Content-Type: text/html; charset=UTF-8');

		foreach ( $admins as $admin ) {
			$result = wp_mail($admin->user_email, $subject, $message, $headers);
		}
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		echo json_encode(get_posts('posts_per_page=-1&post_type=' . $_POST['post_type']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_categories() {

		echo json_encode(get_categories());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Tags
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_tags() {

		echo json_encode(get_tags());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Save the send weekly email setting
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function send_weekly_email() {

		$global_settings = get_option(WPsite_Popup::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if ($_POST['send_weekly_email'] == 'true') {
			$global_settings['send_weekly_email'] = true;
		} else {
			$global_settings['send_weekly_email'] = false;
		}

		update_option(WPsite_Popup::$prefix . 'global_settings', $global_settings);

		echo '';
		die();
	}

	/**
	 * Get all MailChimp Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mailchimp_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {
			require_once(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/mailchimp/MailChimp.php');

			$MailChimp = new WPS_MailChimp($_POST['api_key']);
			$lists = $MailChimp->call('lists/list');

			if (isset($lists) && is_array($lists)) {

				foreach ($lists['data'] as $list) {
					$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
				}

				if (isset($_POST['list']) && $_POST['list'] != '') {
					$options = '';
					foreach ($lists['data'] as $list) {

						if ($_POST['list'] == $list['id']) {
							$options .= '<option value="' . $list['id'] . '" selected="selected">' .  $list['name']. '</option>';
						} else {
							$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the Aweber lists for an account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_aweber_lists() {

		$options = '';
		$consumerKey = '';
		$consumerSecret = '';
		$accessKey = '';
		$accessSecret = '';

		if (isset($_POST['code']) && $_POST['code'] != '') {

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(WPSITE_POPUP_PLUGIN_DIR . 'admin/model/db.php');

			try {
				$credentials = AWeberAPI::getDataFromAweberID($_POST['code']);
				list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $credentials;


				$consumerKey = isset($consumerKey) && !empty($consumerKey) ? $consumerKey : '';
				$consumerSecret = isset($consumerSecret) && !empty($consumerSecret) ? $consumerSecret : '';
				$accessKey = isset($accessKey) && !empty($accessKey) ? $accessKey : '';
				$accessSecret = isset($accessSecret) && !empty($accessSecret) ? $accessSecret : '';
			} catch (AWeberAPIException $exc) {
				error_log($exc);
			}

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				foreach ($lists as $list) {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		if (isset($_POST['list']) && $_POST['list'] != '') {

			$consumerKey     = $_POST['consumer_key'];
			$consumerSecret  = $_POST['consumer_secret'];
			$accessKey       = $_POST['access_key'];
			$accessSecret    = $_POST['access_secret'];

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(WPSITE_POPUP_PLUGIN_DIR . 'admin/model/db.php');

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				$options = '';
				foreach ($lists as $list) {
					if ($_POST['list'] == $list->id) {
						$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
					} else {
						$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
					}
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		echo json_encode(array(
			'html'               => $options,
			'consumer_key'       => $consumerKey,
			'consumer_secret'    => $consumerSecret,
			'access_key'         => $accessKey,
			'access_secret'      => $accessSecret,
		));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Get Repsonse Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_getresponse_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/getresponse/jsonRPCClient.php');
			$api = new jsonRPCClient('http://api2.getresponse.com');

			try {
				$result = $api->get_campaigns($_POST['api_key']);
				foreach ((array) $result as $k => $v) {
					$campaigns[] = array('id' => $k, 'name' => $v['name']);
				}
			}

			catch (Exception $e) {}

			if (isset($campaigns) && is_array($campaigns)) {

				foreach ($campaigns as $campaign) {
					$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
				}

				if (isset($_POST['campaign']) && $_POST['campaign'] != '') {
					$options = '';
					foreach ($campaigns as $campaign) {

						if ($_POST['campaign'] == $campaign['id']) {
							$options .= '<option value="' . $campaign['id'] . '" selected="selected">' .  $campaign['name'] . '</option>';
						} else {
							$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_campaignmonitor_lists() {

		$lists = '';
		$clients = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');
			$auth = array('api_key' => $_POST['api_key']);
			$wrap = new CS_REST_General($auth);
			$result = $wrap->get_clients();


			if ($result->was_successful()) {

				foreach ($result->response as $client) {
					$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$clients = '';
					foreach ($result->response as $client) {
						if ($_POST['client'] == $client->ClientID) {
							$clients .= '<option value="' . $client->ClientID . '" selected="selected">' .  $client->Name . '</option>';
						} else {
							$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
						}
					}
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$client_id = $_POST['client'];
				} else {
					$client_id = $result->response[0]->ClientID;
				}

				$wrap = new CS_REST_Clients($client_id, $_POST['api_key']);
				$result = $wrap->get_lists();

				if ($result->was_successful()) {
					foreach ($result->response as $list) {
						$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
					}

					if (isset($_POST['list']) && $_POST['list'] != '') {
						$lists = '';
						foreach ($result->response as $list) {
							if ($_POST['list'] == $list->ListID) {
								$lists .= '<option value="' . $list->ListID . '" selected="selected">' .  $list->Name . '</option>';
							} else {
								$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
							}
						}
					}
				}
			}
		}

		echo json_encode(array('clients' => $clients, 'lists' => $lists));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Update all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function update_campaignmonitor_lists() {

		$lists = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['client_id']) && $_POST['client_id'] != '') {

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');


			$wrap = new CS_REST_Clients($_POST['client_id'], $_POST['api_key']);
			$result = $wrap->get_lists();


			if ($result->was_successful()) {
				foreach ($result->response as $list) {
					$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
				}
			}
		}

		echo $lists;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Mad Mimi Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_madmimi_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['username']) && $_POST['username'] != '') {

			require(WPSITE_POPUP_PLUGIN_DIR . 'core/includes/madmimi/MadMimi.class.php');

			$mailer = new MadMimi($_POST['username'], $_POST['api_key']);

			if (isset($mailer)) {
				try {
					$lists = $mailer->Lists();
					$lists  = new SimpleXMLElement($lists);

				    if ($lists->list) {
						foreach ($lists->list as $l) {
							$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
						}
				    }

				    if (isset($_POST['list']) && $_POST['list'] != '') {
					    $options = '';
						foreach ($lists->list as $l) {

							if ($_POST['list'] == $l->attributes()->{'name'}->{0}) {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '" selected="selected">' .  $l->attributes()->{'name'}->{0} . '</option>';
							} else {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
							}
						}
					}
				} catch (Exception $exc) {}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all the infusionsoft lists for specfic account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_infusionsoft_lists() {

		if ( ! function_exists( 'curl_init' ) ) {
			return __( 'curl_init is not defined ', WPsite_Popup::$text_domain);
		}

		if ( ! class_exists( 'iSDK' ) ) {
			require_once( WPSITE_POPUP_PLUGIN_DIR . 'core/includes/infusionsoft/isdk.php' );
		}

		$options = '';

		// Make sure the use entered in the api key

		if (isset($_POST['app_id']) && $_POST['app_id'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '') {

			try {
				$infusion_app = new iSDK();
				$infusion_app->cfgCon( $_POST['app_id'], $_POST['api_key'], 'throw' );
			} catch( iSDKException $e ){
				$error_message = $e->getMessage();
			}

			if ( empty( $error_message ) ) {
				$need_request = true;
				$page = 0;
				$all_lists = array();

				while ( true == $need_request ) {
					$error_message = 'success';
					$lists_data = $infusion_app->dsQuery( 'ContactGroup', 1000, $page, array( 'Id' => '%' ), array( 'Id', 'GroupName' ) );
					$all_lists = array_merge( $all_lists, $lists_data );

					if ( 1000 > count( $lists_data ) ) {
						$need_request = false;
					} else {
						$page++;
					}
				}
			}

			// Get all list information

			if ( ! empty( $all_lists ) ) {
				foreach( $all_lists as $list ) {

					if ($_POST['list'] == $list['Id']) {
						$options .= '<option value="' . $list['Id'] . '" selected="selected">' .  $list['GroupName'] . '</option>';
					} else {
						$options .= '<option value="' . $list['Id'] . '">' .  $list['GroupName'] . '</option>';
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Get all the MyMail lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mymail_lists() {

		if ( !function_exists('mymail') ) {
			echo '';
			die();
		}

		$lists = mymail('lists')->get();
		$options = '';

		foreach ( $lists as $list ) {
			if ($_POST['list'] == $list->ID) {
				$options .= '<option value="' . $list->ID . '" selected="selected">' .  $list->name . '</option>';
			} else {
				$options .= '<option value="' . $list->ID . '">' .  $list->name . '</option>';
			}
		}

		echo $options;
		die();
	}

	/**
	 * Get all the Active Campaign lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_activecampaign_lists() {

		require_once( WPSITE_POPUP_PLUGIN_DIR . 'core/includes/activecampaign/ActiveCampaign.class.php' );

		$options = '';

		if ( isset($_POST['app_url']) && $_POST['app_url'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '' ) {

			$ac = new ActiveCampaign($_POST['app_url'], $_POST['api_key']);

			if ( !(int)$ac->credentials_test() ) {

				echo "";
				exit();
			}

			$lists = $ac->api("list/list?ids=all");

			foreach ( $lists as $list ) {

				if ( !isset($list->id) || empty($list->id) ) {
					continue;
				}

				if ($_POST['list'] == $list->id) {
					$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
				} else {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}
			}
		}

		echo $options;
		die();
	}

	/**
	 * Clear all transients related to this popup
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function clear_popup_cache() {

		if (!isset($_POST['popup_id'])) {

			echo ('No popup id so we could not clear the cache.');

			die();
		}

		global $wpdb;

		$query = $wpdb->query($wpdb->prepare(
			"DELETE FROM {$wpdb->options}
			WHERE option_name LIKE %s", '%' . $wpdb->esc_like('_wpsite_popup_dismiss_' . $_POST['popup_id']) . '%'));

		echo ('We were able to clear the cache.');

		die();
	}

	/**
	 * Checks for element in multidimentional aray
	 *
	 * @access public
	 * @static
	 * @param mixed $needle
	 * @param mixed $haystack
	 * @param bool $strict (default: false)
	 * @return void
	 */
	static function in_array_r($needle, $haystack, $strict = false) {
	    foreach ($haystack as $item) {
	        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && self::in_array_r($needle, $item, $strict))) {
	            return true;
	        }
	    }

	    return false;
	}

	/**
	 * Mulit-byte Unserialize
	 *
	 * UTF-8 will screw up a serialized string
	 *
	 * @access private
	 * @param string
	 * @return string
	 */
	static function mb_unserialize($string) {
	    $string2 = preg_replace_callback(
	        '!s:(\d+):"(.*?)";!s',
	        function($m){
	            $len = strlen($m[2]);
	            $result = "s:$len:\"{$m[2]}\";";
	            return $result;

	        },
	        $string);
	    return unserialize($string2);
	}

}

//endif;